{*******************************************************}
{    Program-test for component PColor.                 }
{    Filatkin, Andrey. 21.02.99                         }
{*******************************************************}
unit UnitTest;

{$DEFINE VARIANT2}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Pcolor, Math, ImgList, ComCtrls, ToolWin;

type
  TTestPcolor = class(TForm)
    Pcolor1: TPcolor;
    Button1: TButton;
    ColorDialog1: TColorDialog;
    ToolBar1: TToolBar;
    tbFlat: TToolButton;
    tbInterp: TToolButton;
    tbContour: TToolButton;
    imlToolBar: TImageList;
    ToolButton4: TToolButton;
    tbLine: TToolButton;
    tbRandom: TToolButton;
    tbSpectr: TToolButton;
    FontDialog1: TFontDialog;
    PageControl1: TPageControl;
    tsAxes: TTabSheet;
    tsImage: TTabSheet;
    GroupBox1: TGroupBox;
    btnColorGrid: TButton;
    btnColorImageFon: TButton;
    btnColorMin: TButton;
    btnColorMax: TButton;
    btnColorFon: TButton;
    CheckBox1: TCheckBox;
    tsTitle: TTabSheet;
    btnTitleFont: TButton;
    cbTitleVisible: TCheckBox;
    edtTitle: TEdit;
    tsFigure: TTabSheet;
    Label3: TLabel;
    edtContourLines: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    edtX: TEdit;
    edtY: TEdit;
    StatusBar1: TStatusBar;
    tsZoom: TTabSheet;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    edtLogLeft: TEdit;
    edtLogTop: TEdit;
    edtLogRight: TEdit;
    edtLogBottom: TEdit;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    edtCentreX: TEdit;
    edtCentreY: TEdit;
    edtHorZoom: TEdit;
    edtVerZoom: TEdit;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    edtXMax: TEdit;
    edtXMin: TEdit;
    edtYMax: TEdit;
    edtYMin: TEdit;
    btnSetDefault: TButton;
    btnZoomOut: TButton;
    cbMouseOn: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure btnColorMaxClick(Sender: TObject);
    procedure edtContourLinesKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure tbFlatClick(Sender: TObject);
    procedure tbInterpClick(Sender: TObject);
    procedure tbContourClick(Sender: TObject);
    procedure tbLineClick(Sender: TObject);
    procedure tbRandomClick(Sender: TObject);
    procedure tbSpectrClick(Sender: TObject);
    procedure btnColorImageFonClick(Sender: TObject);
    procedure btnColorGridClick(Sender: TObject);
    procedure btnColorMinClick(Sender: TObject);
    procedure btnColorFonClick(Sender: TObject);
    procedure cbTitleVisibleClick(Sender: TObject);
    procedure edtTitleChange(Sender: TObject);
    procedure btnTitleFontClick(Sender: TObject);
    procedure Pcolor1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure btnSetDefaultClick(Sender: TObject);
    procedure Pcolor1Zoom(Sender: TObject);
    procedure edtLogLeftKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure edtCentreXKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure edtHorZoomKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnZoomOutClick(Sender: TObject);
    procedure cbMouseOnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  TestPcolor: TTestPcolor;

implementation

{$R *.DFM}

procedure TTestPcolor.Button1Click(Sender: TObject);
var
   i,j,XX,YY : integer;
   x,y,XMin,XMax,YMin,YMax,temp : double;
   {$IFNDEF VARIANT2}
   qazx : array of array of double;
   {$ENDIF}
begin
   XX:=StrToInt(edtX.Text);
   YY:=StrToInt(edtY.Text);
   XMax := StrToFloat(edtXMax.Text);
   XMin := StrToFloat(edtXMin.Text);
   YMax := StrToFloat(edtYMax.Text);
   YMin := StrToFloat(edtYMin.Text);

   if XX<2 then XX:=2;
   if YY<2 then YY:=2;
   {$IFDEF VARIANT2}
   pcolor1.SetSizeGraph(XX, YY, XMin, XMax, YMin, YMax);
   {$ELSE}
   setlength(qazx,XX,YY);
   {$ENDIF}
   for i:=0 to XX-1 do
    for j:=0 to YY-1 do
    begin
     x := XMin+i*(XMax-XMin)/(XX-1);
     y := YMin+j*(YMax-YMin)/(YY-1);
     temp := 4*sin(sqrt(x*x+(y-2)*(y-2)))/(sqrt(x*x+(y-2)*(y-2))+0.1)+
                  9*sin(sqrt((x-6)*(x-6)+y*y))/(sqrt((x-6)*(x-6)+y*y)+0.1)+
                  sin(exp(abs(x-5)+abs(y)));
//     temp := y*exp(-y*y-x*x);
//     temp := i+j;
     {$IFDEF VARIANT2}
     pcolor1.Graph[i,j] := temp;
     {$ELSE}
     qazx[i,j] := temp;
     {$ENDIF}
    end;
   pcolor1.ContourLines := StrToInt(edtContourLines.Text);
   {$IFDEF VARIANT2}
   pcolor1.Repaint;
   {$ELSE}
   pcolor1.DrawData(@qazx,XMin,XMax,YMin,YMax);
   {$ENDIF}
end;

procedure TTestPcolor.CheckBox1Click(Sender: TObject);
begin
  pcolor1.DrawFacet := CheckBox1.Checked;
end;

procedure TTestPcolor.btnColorMaxClick(Sender: TObject);
begin
   if ColorDialog1.Execute then
   begin
     pcolor1.ColorMaxValue := ColorDialog1.Color;
   end;
end;

procedure TTestPcolor.edtContourLinesKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = VK_RETURN then
    pcolor1.ContourLines:=StrToInt(edtContourLines.Text);
end;

procedure TTestPcolor.FormCreate(Sender: TObject);
begin
  CheckBox1.Checked := pcolor1.DrawFacet;
  cbTitleVisible.Checked := pcolor1.Title.Visible;
  cbMouseOn.Checked := pcolor1.MouseOn;
  edtTitle.Text := pcolor1.Title.Text;
  edtContourLines.Text :=IntToStr(pcolor1.ContourLines);
end;

procedure TTestPcolor.tbFlatClick(Sender: TObject);
begin
  pcolor1.TypeImage := dtFlat;  
end;

procedure TTestPcolor.tbInterpClick(Sender: TObject);
begin
  pcolor1.TypeImage := dtInterp;
end;

procedure TTestPcolor.tbContourClick(Sender: TObject);
begin
  pcolor1.TypeImage := dtContour;
end;

procedure TTestPcolor.tbLineClick(Sender: TObject);
begin
  Pcolor1.ColorMap := cmLine;
end;

procedure TTestPcolor.tbRandomClick(Sender: TObject);
begin
  Pcolor1.ColorMap := cmRandom;
end;

procedure TTestPcolor.tbSpectrClick(Sender: TObject);
begin
  Pcolor1.ColorMap := cmSpectr;
end;

procedure TTestPcolor.btnColorImageFonClick(Sender: TObject);
begin
   if ColorDialog1.Execute then
   begin
     pcolor1.ColorImageFon := ColorDialog1.Color;
   end;
end;

procedure TTestPcolor.btnColorGridClick(Sender: TObject);
begin
   if ColorDialog1.Execute then
   begin
     pcolor1.ColorGrid := ColorDialog1.Color;
   end;                      
end;

procedure TTestPcolor.btnColorMinClick(Sender: TObject);
begin
   if ColorDialog1.Execute then
   begin
     pcolor1.ColorMinValue := ColorDialog1.Color;
   end;  
end;

procedure TTestPcolor.btnColorFonClick(Sender: TObject);
begin
   if ColorDialog1.Execute then
   begin
     pcolor1.ColorFon := ColorDialog1.Color;
   end;
end;

procedure TTestPcolor.cbTitleVisibleClick(Sender: TObject);
begin
  pcolor1.Title.Visible := cbTitleVisible.Checked ;
end;

procedure TTestPcolor.edtTitleChange(Sender: TObject);
begin
  pcolor1.Title.Text := edtTitle.Text;
end;

procedure TTestPcolor.btnTitleFontClick(Sender: TObject);
begin
   if FontDialog1.Execute then
   begin
     pcolor1.Title.Font := FontDialog1.Font;
   end;
end;

procedure TTestPcolor.Pcolor1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var
  XA, YA : Extended;
begin
  if pcolor1.PosImageToPosLog(X, Y, XA, YA) then
    StatusBar1.SimpleText := Format('X: %2.2f;  Y: %2.2f', [XA, YA]);
end;

procedure TTestPcolor.btnSetDefaultClick(Sender: TObject);
begin
  pcolor1.SetDefaultData;
end;

procedure TTestPcolor.Pcolor1Zoom(Sender: TObject);
begin
  edtLogLeft.Text := Format('%1.8g', [pcolor1.LogLeft]);
  edtLogTop.Text := Format('%1.8g', [pcolor1.LogTop]);
  edtLogRight.Text := Format('%1.8g', [pcolor1.LogRight]);
  edtLogBottom.Text := Format('%1.8g', [pcolor1.LogBottom]);
  edtCentreX.Text := Format('%1.8g', [pcolor1.LogCentreX]);
  edtCentreY.Text := Format('%1.8g', [pcolor1.LogCentreY]);
  edtHorZoom.Text := Format('%1.8g', [pcolor1.HorZoom]);
  edtVerZoom.Text := Format('%1.8g', [pcolor1.VerZoom]);
end;

procedure TTestPcolor.edtLogLeftKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = VK_RETURN then
    pcolor1.ZoomArea(StrToFloat(edtLogLeft.Text),StrToFloat(edtLogTop.Text),StrToFloat(edtLogRight.Text),StrToFloat(edtLogBottom.Text));
end;


procedure TTestPcolor.edtCentreXKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = VK_RETURN then
    pcolor1.ZoomAtPos(StrToFloat(edtCentreX.Text),StrToFloat(edtCentreY.Text));
end;

procedure TTestPcolor.edtHorZoomKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = VK_RETURN then
    pcolor1.ZoomAtTime(StrToFloat(edtHorZoom.Text),StrToFloat(edtVerZoom.Text));
end;

procedure TTestPcolor.btnZoomOutClick(Sender: TObject);
begin
  pcolor1.ZoomOut;
end;

procedure TTestPcolor.cbMouseOnClick(Sender: TObject);
begin
  pcolor1.MouseOn := cbMouseOn.Checked;
end;

end.



